/* Copyright (c) NEC Platforms, Ltd. 2001-2017 */

;(function($, window, document, undefined) {
	
	var formStyle = {
		toggleSwitch:{
			classWrapper:'UIElm-toggle-switch-wrapper',
			classBox:'UIElm-toggle-switch',
			classInner:'UIElm-toggle-switch-inner',
			classLabel:'UIElm-toggle-label',
			classBtn:'UIElm-toggle-switch-btn',
			classBoxOn:'UIElm-toggle-switch-box-on',
			classBoxOff:'UIElm-toggle-switch-box-off',
			classOn:'UIElm-toggle-switch-text-on',
			classOff:'UIElm-toggle-switch-text-off',
			textOn:'ON',
			textOff:'OFF'
		},
		selector:{
			classBox:'UIElm-selector-box',
			classCurrent:'UIElm-selector-selected',
			classIcon:'UIElm-selector-icon',
			srcIcon:'/pic/icon_side_open.png'
		},
		radioBtn:{
			classBox:'UIElm-radio',
			classLabel:'UIElm-radio-label'
		},
		checkbox:{
			classBox:'UIElm-checkbox',
			classLabel:'UIElm-checkbox-label',
			srcIcon:'/pic/icon_check.png'
		}
	};
	
	
	function getNames($selector){
		var result = [];
		var nameCheck = [];
		var newName = true;
		$selector.each(function(){
			var thisName = $(this).attr('name');
			if(thisName != undefined){
				for(var i = 0, l = nameCheck.length; i < l; i++){
					if(thisName == nameCheck[i]){
						newName = false
						break;
					}
				};
				if(newName){
					nameCheck[nameCheck.length] = thisName;
					result[result.length] = thisName;
				};
				newName = true;
			}
		});
		return (result.length > 0)? result : false;
	};
	
	function getNames($selector){
		var result = [];
		var nameCheck = '';
		$selector.each(function(){
			var thisName = $(this).attr('name');
			if(thisName && thisName != nameCheck){
				result[result.length] = nameCheck = thisName;
			}
		});
		return (result.length > 0)? result : false;
	};
	
	$.fn.extend({
		toggleSwitch: function(onStr, offStr){
			var names = formStyle.toggleSwitch;
			if(!onStr || onStr == '') onStr = names.textOn;
			if(!offStr || offStr == '') offStr = names.textOff;
			this.each(function(){
				var element = this;
				var $this = $(element);
				var $parent = $this.parent('label').wrap('<div class="inline"></div>').parent().addClass(names.classWrapper);
				var $label = $this.parent('label').addClass(names.classLabel);
				var $switchBox = $('<span></span>').addClass(names.classBox);
				var $switchTextOn = $('<span></span>').addClass(names.classOn).text(onStr);
				var $switchTextOff = $('<span></span>').addClass(names.classOff).text(offStr);
				var defult = element.checked;
				var disabled = element.disabled;
				if(defult){
					$switchBox.addClass('checked');
					$parent.addClass('checked');
				};
				if(disabled){
					$switchBox.addClass('disabled');
					$parent.addClass('disabled');
				};
				if($this.hasClass('alert')){
					$switchBox.addClass('alert');
					$parent.addClass('alert');
				};
				$switchBox.each(function(){
					var $switchBox = $(this);
					var $switchInner = $('<span></span>').addClass(names.classInner);
					var $switchBtn = $('<span></span>').addClass(names.classBtn);
					var $switchBoxOn = $('<span></span>').addClass(names.classBoxOn);
					var $switchBoxOff = $('<span></span>').addClass(names.classBoxOff);
					
					$switchBoxOn.bind('click', function(){$switchBox.trigger('changeOff');return false;});
					$switchBoxOff.bind('click', function(){$switchBox.trigger('changeOn');return false;});
					$switchTextOn.bind('click', function(){$switchBox.trigger('changeOn');return false;});
					$switchTextOff.bind('click', function(){$switchBox.trigger('changeOff');return false;});
					var defX = 0;
					var eventFlag = false;
					var defPos = 0;
					var pos = 0;
					var result = '';
					$switchBtn.bind('mousedown', function(e){
						eventFlag = !element.disabled;
						defPos = $switchInner.position().left;
						pos = 0;
						defX = e.pageX;
					}).bind('mousemove', function(e){
						if(eventFlag){
							var num = e.pageX - defX;
							pos = num + defPos;
							if(pos > 0) pos = 0;
							if(pos < -45) pos = -45;
							$switchInner.css('left', pos)
						}
					}).bind('mouseup mouseleave', function(e){
						if(eventFlag){
							if(pos == defPos){
								result = (pos > -25)? 'changeOff' : 'changeOn';
							}else{
								result = (pos > -25)? 'changeOn' : 'changeOff';
							}
							$switchBox.trigger(result);
							eventFlag = false;
						}
					}).bind('touchstart touchmove touchend', function(e){
						e.preventDefault(); 
						e.stopImmediatePropagation();
						e.stopPropagation();
						var touch = e.originalEvent.touches[0];
						if(e.type == 'touchstart'){
							eventFlag = !element.disabled;
							defPos = $switchInner.position().left;
							pos = 0;
							defX = touch.pageX;
						}else
						if(e.type == 'touchmove'){
							if(eventFlag){
								var num = touch.pageX - defX;
								pos = num + defPos;
								if(pos > 0) pos = 0;
								if(pos < -45) pos = -45;
								$switchInner.css('left', pos);
							}
						}else
						if(e.type == 'touchend'){
							if(eventFlag){
								if(pos == defPos){
									result = (pos > -25)? 'changeOff' : 'changeOn';
								}else{
									result = (pos > -25)? 'changeOn' : 'changeOff';
								}
								$switchBox.trigger(result);
								eventFlag = false;
							}
						}
						
					});
					
					$switchInner.append($switchBtn).append($switchBoxOn).append($switchBoxOff);
					$switchBox.append($switchInner);
				}).bind('changeOn', function(e){
					var disabled = element.disabled;
					if(!disabled){
						$(this).find('.' + names.classInner).animate({'left': 0}, 'fast', function(){$(this).removeAttr('style')});
						$(this).addClass('checked');
						$parent.addClass('checked');
						if(!$this.context.checked) $this.trigger('click');
					};
				}).bind('changeOff', function(e){
					var disabled = element.disabled;
					if(!disabled){
						$(this).find('.' + names.classInner).animate({'left': -45}, 'fast', function(){$(this).removeAttr('style')});
						$(this).removeClass('checked');
						$parent.removeClass('checked');
						if($this.context.checked) $this.trigger('click');
					};
				}).bind('mousedown', function(){
					return false;
				});
				$this.bind('disabled', function(e, flag){
					if(flag){
						$switchBox.addClass('disabled');
						$parent.addClass('disabled');
					}else{
						$switchBox.removeClass('disabled');
						$parent.removeClass('disabled');
					}
				}).bind('setAlert', function(e, arg){
					if(arg == 'toggle') arg = $switchBox.hasClass('alert') == false;
					$switchBox.toggleClass('alert', arg);
				}).bind('checked', function(e, flag){
					if(flag != undefined) $this.context.checked = flag;
					if($this.context.checked){
						$switchBox.addClass('checked');
						$parent.addClass('checked');
					}else{
						$switchBox.removeClass('checked');
						$parent.removeClass('checked');
					};
				}).bind('change', function(e){
					if($this.context.checked){
						$switchBox.trigger('changeOn');
					}else{
						$switchBox.trigger('changeOff');
					};
				});
				$parent.prepend($switchTextOn).prepend($switchBox).prepend($switchTextOff);
				var switchWidth = $switchBox.outerWidth() + $switchTextOn.outerWidth() + $switchTextOff.outerWidth();
				$parent.css('min-width', switchWidth)
				$(window).bind('resize', function(e){
				  var switchWidth = $switchBox.outerWidth() + $switchTextOn.outerWidth() + $switchTextOff.outerWidth();
				  $parent.css('min-width', switchWidth)
				});
			});
			return this;
		},
		selector: function(){
			var names = formStyle.selector;
			var setHFlag = false;
			this.each(function(){
				var element = this;
				var $this = $(element);
				var $div = $('<div></div>').addClass(names.classBox);
				var $span = $('<span></span>').addClass(names.classCurrent);
				var $icon = $('<span></span>').addClass(names.classIcon);
				var currentText = $this.find('option:selected').text();
				var disabled = $this.attr('disabled');
				var maxLength = (function(className){
					var result = false;
					if(className){
					  className = className.split(' ');
					  for(var i = 0, l = className.length; i < l; i++){
						  if(/^maxLength/.test(className[i])) result = className[i].split('maxLength')[1] - 0;
					  };
					};
					return result;
				})($this.attr('class'));
				if(disabled) $div.addClass('disabled');
				if($this.hasClass('alert')) $div.addClass('alert');
				if(maxLength) if(currentText.length > maxLength) currentText = currentText.substr(0, maxLength) + '...';
				$span.text(currentText);
				$icon.append('<img src="' + names.srcIcon + '" alt="">');
				$this.wrap($div).parent().prepend($span).prepend($icon).end().bind('change', function(){
					$(this).trigger('checked');
				}).bind('disabled', function(e, flag){
					if(flag){
						$(this).parent().addClass('disabled');
					}else{
						$(this).parent().removeClass('disabled');
					}
				}).bind('setAlert', function(e, arg){
					if(arg == 'toggle') arg = $(this).parent().hasClass('alert') == false;
					$(this).parent().toggleClass('alert', arg);
				}).bind('checked', function(e, flag){
					currentText = $(this).find('option:selected').text();
					if(maxLength) if(currentText.length > maxLength) currentText = currentText.substr(0, maxLength) + '...';
					$span.text(currentText);
					if(setHFlag) $(this).trigger('setH');//for IE7
				}).bind('setH', function(e){//for IE7
					var h = $(this).parent().height();
					$(this).height(h);
				}).find('option').bind('checked', function(e, flag){
					if(!this.selected) this.selected = true;
					$(this).parent().trigger('checked');
				});
			});
			this.each(function(){//for IE7
				var $this = $(this);
				if($this.height() != $this.parent().height() && $this.parent().height() > 0){
				  setHFlag = true;
				  $this.trigger('setH');
				  $(window).bind('resize', function(){
					$this.trigger('setH');
				  });
				}
			});
			return this;
		},
		radioBtn: function(radioNames){
			this.each(function(){
				var $form = $(this);
				$form.each(function(){
					var $this = $(this);
					for(var i = 0, l = radioNames.length; i < l; i++){
						$this.find('input[name="' + radioNames[i] + '"]').setRadioBtn();
					}
				});
			});
			return this;
		},
		setRadioBtn: function(radioNames){
			var $thisGroup = this;
			var names = formStyle.radioBtn;
			$thisGroup.each(function(){
				var element = this;
				var $this = $(element);
				var $label = $this.parent('label').addClass(names.classLabel);
				var $span = $('<span></span>').addClass(names.classBox);
				var disabled = $this.attr('disabled');
				if(disabled) $label.addClass('disabled');
				if($this.hasClass('alert')) $label.addClass('alert');
				$this.bind('change', function(){
					$(this).trigger('checked');
				}).bind('checked', function(){
					if(!element.checked) element.checked = true;
					$thisGroup.each(function(){
						$(this).parent('label').removeClass('checked')
					});
					$thisGroup.filter(':checked').each(function(){
						$(this).parent('label').addClass('checked');
					})
				}).bind('disabled', function(e, flag){
					if(flag){
						$label.addClass('disabled');
					}else{
						$label.removeClass('disabled');
					}
				}).bind('setAlert', function(e, arg){
					if(arg == 'toggle') arg = $label.hasClass('alert') == false;
					$label.toggleClass('alert', arg);
				});
				$label.prepend($span);
			});
			$thisGroup.filter(':checked').each(function(){
				$(this).parent('label').addClass('checked');
			})
			return $thisGroup;
		},
		checkbox: function(){
			var names = formStyle.checkbox;
			this.each(function(){
				var element = this;
				var $this = $(element);
				var $label = $this.parent('label').addClass(names.classLabel);
				var $span = $('<span></span>').addClass(names.classBox);
				var disabled = $this.attr('disabled');
				if(disabled) $label.addClass('disabled');
				if(element.checked) $label.addClass('checked');
				if($this.hasClass('alert')) $label.addClass('alert');
				$this.bind('change', function(){
					$this.trigger('checked');
				}).bind('checked', function(e, flag){
					if(flag != undefined) $this.context.checked = flag;
					if($this.context.checked){
						$label.addClass('checked');
					}else{
						$label.removeClass('checked');
					};
				}).bind('disabled', function(e, flag){
					if(flag){
						$label.addClass('disabled');
					}else{
						$label.removeClass('disabled');
					}
				}).bind('setAlert', function(e, arg){
					if(arg == 'toggle') arg = $label.hasClass('alert') == false;
					$label.toggleClass('alert', arg);
				});
				var $icon = $('<img src="' + names.srcIcon + '" alt="">').click(function(){$this.click();return false;});
				$span.append($icon);
				$label.prepend($span);
			});
			return this;
		},
		disabled: function(arg){
			this.each(function(){
				var $this = $(this);
				if($this.get(0).tagName == 'INPUT' || $this.get(0).tagName == 'SELECT'){
					if(arg == undefined) arg = $this.attr('disabled') == undefined;
					if(arg){
						$this.attr('disabled', 'disabled').trigger('disabled', [arg]);
					}else{
						$this.removeAttr('disabled').trigger('disabled', [arg]);
					};
				}else{
					if(arg == undefined) arg = !$this.hasClass('disabled');
					if(arg){
						$this.addClass('disabled').bind('click', btnOff);
					}else{
						$this.removeClass('disabled').unbind('click', btnOff);
					};
				}
			});
			return this;
		},
		setAlert: function(arg){
			this.each(function(){
				var $this = $(this);
				if(arg == undefined) arg = 'toggle';
				$this.toggleClass('alert',  (arg == 'toggle')? $this.hasClass('alert') == false: arg).trigger('setAlert', [arg]);
			});
			return this;
		},
		checked: function(arg){
			this.each(function(index){
				var $this = $(this);
				var $parent = $this.parent();
				if($this.get(0).tagName == 'INPUT' && $this.attr('type') == 'checkbox'){
					if(arg == undefined) arg = $this.attr('checked') == undefined;
					if(arg){
						$this.attr('checked', 'checked').trigger('checked', [arg]);
					}else{
						$this.removeAttr('checked').trigger('checked', [arg]);
					};
				}else if($this.get(0).tagName == 'INPUT' && $this.attr('type') == 'radio'){
					if(arg == undefined) arg = true;
					if(typeof arg == 'boolean'){
						$this.trigger('checked');
					}else if(typeof arg == 'number'){
						if(index == arg) $this.trigger('checked');
					};
				}else if($this.get(0).tagName == 'OPTION'){
					if(arg == undefined) arg = true;
					if(arg){
						$this.trigger('checked');
					};
				}else if($this.get(0).tagName == 'SELECT'){
					if(arg == undefined) arg = 0;
					if(typeof arg == 'number'){
						$this.find('option:eq(' + arg + ')').trigger('checked');
					};
				}
			});
			return this;
		}
	});
	
	function btnOff(){
		return false;
	}
	
	$(function() {
		
		$('.btn.disabled').bind('click', btnOff);
		$('form').each(function(){
			var $this = $(this);
			$this.radioBtn(getNames($this.find('input[type="radio"]')));
		});
		$('input[type="checkbox"]:not(.simpleCheckBox)').each(function(){
			var str = $(this).attr('title');
			var onStr = undefined;
			var offStr = undefined;
			if(str){
				str = str.split('/');
				if(str.length == 2){
					onStr = str[0];
					offStr = str[1];
				};
			};
			$(this).toggleSwitch(onStr, offStr);
		});
		$('input.simpleCheckBox').each(function(){
			$(this).checkbox();
		});
		$('select').each(function(){
			$(this).selector();
		});
	});

}(jQuery, window, document));
